'use strict';

const spawn = require('child_process').spawn;
const argv  = require('optimist').argv;

function runElectron(electronPath, testsPath) {
    const electron = spawn(electronPath, [testsPath]);
    let hasErrors = false;

    // Cleanup Electron output to be TAP (test anything protocol) compliant
    electron.stdout.on('data', function (data) {
        data = data.toString('utf8');
        data.split('[qunit-logger] ').slice(1).forEach((line) => {
            process.stdout.write(`${line}\n`);

            if (line === '# done with errors') {
                hasErrors = true;
            }

            if (line.indexOf('# done') > -1) {
                electron.kill();
                process.exit(hasErrors ? 1 : 0);
            }
        });
    });
}

runElectron(argv['electron-path'], argv['tests-path']);
